##########################################################################################################################
# This program creates the required tools to improve the BCS programs that use cif files if it is integrated into the BCS#
#                                                                                                                        #
#########################################################################################################################
import datasearchandprint
import cifprogram
import name_exception
import sys


class Logger(object):
    def __init__(self, filename="Default.log"):
        self.terminal = sys.stdout
        self.log = open(filename, "w")

    def write(self, message):
        self.terminal.write(message)
        self.log.write(message)
        self.log.close
        


programname=raw_input("Introduce the name of the program you want to use: ")

if programname=='amplimodes' or programname=='twin domains'or programname=='raman correlation space' \
or programname=='structure relations':

  cif1=name_exception.file_name1("high")
  dn1=datasearchandprint.dataname(cif1)
  lendn1=len(dn1)
  
  if lendn1==0:
    sys.stdout = Logger("errors.txt")
    print ""
    print "CifBuilderError this file does not content any valid structure, please introduce again a valid cif file"
    sys.exit()
  if lendn1!=1:
    datasearchandprint.printdata(dn1)
    dn1u=int(raw_input("Introduce the number of the structure you want to use :"))
    
    dataname=dn1[dn1u-1]
    datasearchandprint.cifdata(cif1,'cif1mod.cif',dataname)
  else:
    dataname=dn1[0]
    datasearchandprint.cifdata(cif1,'cif1mod.cif',dataname)
  
  cifprogram.cifcreation(programname,'cif1mod.cif',dataname,"cifshort1.cif","Initial_str1.txt")
  
  cif2= name_exception.file_name1("low")
  dn2=datasearchandprint.dataname(cif2)
  lendn2=len(dn2)
  
  if lendn2==0:
    sys.stdout = Logger("errors.txt")
    print ""
    print "CifBuilderError this file does not content any valid structure, please introduce again a valid cif file"
    sys.exit()
  if lendn2!=1:
    datasearchandprint.printdata(dn2)
    dn2u=int(raw_input("Introduce the number of the structure you want to use :")) 
    
    
    dataname=dn2[dn2u-1]
    datasearchandprint.cifdata(cif2,'cif2mod.cif',dataname)
    
  else:
    dataname=dn2[0]
    datasearchandprint.cifdata(cif2,'cif2mod.cif',dataname)
    dn2u=1
  
  cifprogram.cifcreation(programname,'cif2mod.cif',dataname,"cifshort2.cif","Initial_str2.txt")
  sys.stdout = Logger("errors.txt")
elif programname=='compstru':

  cif1=name_exception.file_name2("first")
  dn1=datasearchandprint.dataname(cif1)
  lendn1=len(dn1)
  
  if lendn1==0:  
    sys.stdout = Logger("errors.txt")
    print ""
    print "CifBuilderError this file does not content any valid structure, please introduce again a valid cif file"
    sys.exit()

  if lendn1!=1:
    datasearchandprint.printdata(dn1)
    dn1u=int(raw_input("Introduce the number of the structure you want to use :"))
    dataname=dn1[dn1u-1]
    datasearchandprint.cifdata(cif1,'cif1mod.cif',dataname)
  else:
    dataname=dn1[0]
    datasearchandprint.cifdata(cif1,'cif1mod.cif',dataname)
     
  print " "
  cifprogram.cifcreation(programname,'cif1mod.cif',dataname,"cifshort1.cif","Initial_str1.txt")
  cif2=name_exception.file_name2("second")
  dn2=datasearchandprint.dataname(cif2)
  lendn2=len(dn2)
  
  if lendn2==0:
    sys.stdout = Logger("errors.txt")
    print ""
    print "CifBuilderError this file does not content any valid structure, please introduce again a valid cif file"
    sys.exit()

  if lendn2!=1:
    datasearchandprint.printdata(dn2)
    dn2u=int(raw_input("Introduce the number of the structure you want to use :")) 
    
    dataname=dn2[dn2u-1]
    datasearchandprint.cifdata(cif2,'cif2mod.cif',dataname)
  else:
    dataname=dn2[0]
    datasearchandprint.cifdata(cif2,'cif2mod.cif',dataname)

  
  cifprogram.cifcreation(programname,'cif2mod.cif',dataname,"cifshort2.cif","Initial_str2.txt")
  sys.stdout = Logger("errors.txt")
  
elif programname=='pseudo' or programname=='dope' or programname=='wpassign' or programname=='transtru'\
or programname=='setstru' or programname=='equivstru' or programname=='strconvert' or programname=='visualize' or programname=='sam':

   cif1=name_exception.file_name3()
   dn1=datasearchandprint.dataname(cif1)
   
   lendn1=len(dn1) 
   
   if lendn1==0:
     sys.stdout = Logger("errors.txt")
     print ""
     print "CifBuilderError this file does not content any valid structure, please introduce again a valid cif file"
     sys.exit()
     
   if lendn1!=1:
    datasearchandprint.printdata(dn1)
    dn1u=int(raw_input("Introduce the number of the structure you want to use :"))
    
    dataname=dn1[dn1u-1]
    datasearchandprint.cifdata(cif1,'cif1mod.cif',dataname)

   else:
    dataname=dn1[0]
    datasearchandprint.cifdata(cif1,'cif1mod.cif',dataname)
   cifprogram.cifcreation(programname,'cif1mod.cif',dataname,"cifshort1.cif","Initial_str1.txt")
   sys.stdout = Logger("errors.txt")

